library(readr)
library(dplyr)
library(tidyr)
library(sf)
library(ggplot2)
library(outliers)
#library(stringr)

setwd("C:/Users/hmathian/Desktop/ExploSHSAteliers/AtelierNettoyage/LyonOutliers")

Carro200m <- st_read(dsn="MetropLyonMaille200m/Carro200m2015GLyonW.shp", 
                     stringsAsFactors = FALSE, 
                     options = "ENCODING=latin1")
#Regarder la distribution des variables

ggplot(data=Carro200m)+
  geom_histogram(aes(x=Ind_snvmoy), fill="green")
ggplot(data=Carro200m)+
  geom_histogram(aes(x=PMen_pauv), fill="red")

#Détection de soutliers par critère de Tukey et percentiles
summary(Carro200m$Ind_snvmoy)

boxplot(Carro200m$Ind_snvmoy,
        ylab = "revenu moyen par hab")

ggplot(data=Carro200m,aes(y=Ind_snvmoy))+
  geom_boxplot(fill = "green") +
  theme_minimal()


boxplot.stats(Carro200m$Ind_snvmoy)$out
outlier <- boxplot.stats(Carro200m$Ind_snvmoy)$out
outliers_indiv <- Carro200m[which(Carro200m$Ind_snvmoy %in% c(outlier)),]



# Méthodes des percentiles
# DAns cette méthode toutes les observations qui se situent
# hors de l'intervalle formé par les percentles 2.5 et 97.5 sont des outliers potentielst

#on peut tester aussi l'intervalle de 1% et 99%
test<-Carro200m[is.na(Carro200m$Ind_snvmoy),]
lower_bound <- quantile(Carro200m$Ind_snvmoy, 0.025,na.rm=TRUE)
lower_bound
upper_bound <- quantile(Carro200m$Ind_snvmoy, 0.975,na.rm=TRUE)
upper_bound

outliers_indiv <- which(Carro200m$Ind_snvmoy < lower_bound 
                     | Carro200m$Ind_snvmoy> upper_bound)
Toutlier_ind<-Carro200m[outliers_indiv ,] 


#Par test statistique
# test de Grubbs=> test des valeurs max une par une
# Rosner’s test=> test de plusieurs valeurs en même temps

#TEST DE GRUBBS
# install.packages("outliers")
library(outliers)
T<-Carro200m
test <- grubbs.test(T$Ind_snvmoy)
test

T<-T[T$Ind_snvmoy<max(T$Ind_snvmoy),]
test <- grubbs.test(T$Ind_snvmoy)
test

#and again , and again...

#TEST DE ROSNER
# install.packages("EnvStats")
library(EnvStats)
test <- rosnerTest(Carro200m$Ind_snvmoy,
                   k = 6)
test
test$all.stats

T<-Carro200m
T[which.max(T$Ind_snvmoy),]$Ind_snvmoy<-7000000
max(T$Ind_snvmoy)
rosnerTest(T$Ind_snvmoy, k = 6)$all.stats
